package com.mamezou.aspectjannotation;

import org.aspectj.lang.ProceedingJoinPoint;
import org.aspectj.lang.annotation.After;
import org.aspectj.lang.annotation.AfterReturning;
import org.aspectj.lang.annotation.AfterThrowing;
import org.aspectj.lang.annotation.Around;
import org.aspectj.lang.annotation.Aspect;
import org.aspectj.lang.annotation.Before;

@Aspect
public class AopExAspect {
    @After("execution(* exMethod())")
    public void after() {
        // \bhIWeavingAdvice
        System.out.println("after called");
    }

    @Before("execution(* exMethod())")
    public void before() {
        // \bhJnWeavingAdvice
        System.out.println("before called");
    }

    @Around("execution(* exMethod())")
    public void around(ProceedingJoinPoint pjp) throws Throwable {
        // \bhďȏOWeavingAdvice
        System.out.println("pre proceed");
        pjp.proceed();
        System.out.println("post proceed");
    }

    @AfterReturning(value="execution(* exMethod())", returning="ret")
    public void afterReturning(String ret) {
        // \bhďoȎoȂɏIۂɌĂ΂Advice
        System.out.println("after returning called");
        System.out.println("return value = " + ret);
    }
    
    @AfterThrowing(value="execution(* exMethod())", throwing="ex")
    public void afterThrowing(Throwable ex) {
        // \bhďoŗOoꂽۂɌĂ΂Advice
        System.out.println("after throwing called");
        System.out.println("exception value = " + ex.toString());
    }
}
